// minimums
var vSize = 100;
var hSize = 212;
var last_delta_x = 1;
function mouseDown(event)
{
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event)
{
	var screenX = event.x + window.screenX;
	var screenY = event.y + window.screenY;
	var deltaX = 0;
	var deltaY = 0;
	
	if ( (window.innerWidth + (screenX - lastPos.x)) >= hSize ) {
		deltaX = screenX - lastPos.x;
		lastPos.x = screenX;
	}  
	
	// Workaround for the webkit bug that does not update y when x is not changed.
	if (deltaX == 0 && last_delta_x == 1) {
		deltaX = -1;
		last_delta_x = -1;
	} else if (deltaX == 0 && last_delta_x == -1){
		deltaX = 1;
		last_delta_x = 1;
	}
	
	if ( (window.innerHeight + (screenY - lastPos.y)) >= vSize ) {
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}
	var tempx = parseInt(document.getElementById('front').style.width);
	//alert("!! "+tempx+ document.getElementById('front').style.width + " "  + deltaX );
// 	document.getElementById('front').style.width = tempx + deltaX; // disabled x changes
	var tempy = parseInt(document.getElementById('front').style.height);
	document.getElementById('front').style.height = tempy + deltaY;
	// 	document.getElementById('front').style.height = parseInt(document.getElementById('front').style.height) + deltaY;
	window.resizeBy(deltaX, deltaY);
	// document.getElementById('front').style.height = "10px";
	// document.getElementById('front').style.width = "100%";
	// alert ("resized delta x = " + deltaX + "   delta y = " + deltaY);
	// calculateAndShowThumb(document.getElementById('main'));
	scrollbar.refresh();
	scrollArea.refresh();
//  alert (scrollbar.hidden + " " + scrollbar.autohide);
	event.stopPropagation();
	event.preventDefault();
	// var temp_ht1  = document.getElementById('front').style.height;
	widget.setPreferenceForKey(window.innerHeight,"win_height");
	//			alert (" ht pref = " + widget.preferenceForKey("win_height"));

} 
function mouseUp(event)
{
	var newWidth = parseInt(document.getElementById('front').style.width);
	var newHeight = parseInt(document.getElementById('front').style.height);
	window.resizeTo(newWidth, newHeight);
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	event.stopPropagation();
	event.preventDefault();
	// setDefaultMaxSize(newWidth, newHeight);
}
function setDefaultMaxSize(x, y) {
//	alert('setDefaultSize, x: '+x+' y: '+y)
	if (typeof(x) == "undefined" || x == "undefined" || x == '') {
		x = hSize;
	}
	if (typeof(y) == "undefined" || y == "undefined" || y == '' || y < vSize) {
		y = vSize;
	}
	
	widget.setPreferenceForKey(x, createKey("defaultMaxX"));
	widget.setPreferenceForKey(y, createKey("defaultMaxY"));		
}
function createKey(name) {
	return widget.identifier + "-" + name;
}

