/* 
	-- AirportRadar.js
	-- AirportRadar
	
	-- Created by william davies on 23 May 2005
	-- Copyright (c) 2005-2006  All rights reserved.
*/

var memory_duration = 5;
var scan_interval = 1785;
var sort_by = "ssid";
// var max_win_height = 8;
var waiting_to_scan, no_scan_results, hidden="0", the_scan, scan_output = null, items, power_it_off, my_path, sweep_table, output_lines, step_a, step_b, out_count, power_stat, win_size, stretcher, my_connected_mac_add, power_state="on", scrollbar, scrollArea, restore_scrollbar, had_success;
var scan_cycle = null;//setInterval("radar_scan();", scan_interval);
var sweep_loc = "radar_sweep -s";
var previous_sweep = 0;
var first_time = 1;
var happening = 0;
var redrawing = 0;
var scan_errors = 0;
var ssid_link = "";
var home_test = null;
var machine_test = null;
var tree=new Array();
var index=new Array();
var parsed_already = "0";



if(window.widget){
	widget.onshow = onshow;
	widget.onhide = onhide;
	widget.onremove = onremove;
}

function initial () {
	// alert('initial');
   
	scrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollBar"));
	// scrollbar.setAutohide(1);
	scrollArea = new AppleScrollArea(document.getElementById("sweep_chart"));
	scrollArea.addScrollbar(scrollbar);
	scrollbar.refresh();
	scrollArea.refresh();
	scrollArea.scrollsHorizontally = false;
	scrollArea.singlepressScrollPixels = 25;
	scrollArea.focus(); // for key control when first loading in Safari

	if(window.widget) {
		document.getElementById("sweep_chart").innerHTML = "<center style='color:#aaaaaa; padding-top: 35px; font-weight:bold; font-size:16pt;'>Scanning...</center>";
		//home_test = widget.system("~/Library/Widgets/Airport\\ Radar.wdgt/radar_sweep -p", null).errorString;
		// machine_test = widget.system("/Library/Widgets/Airport\\ Radar.wdgt/radar_sweep -p", null).errorString;
		if (home_test == null) { my_path = "~/Library/Widgets/Airport\\ Radar.wdgt/"; }			
		if (machine_test == null) { my_path = "/Library/Widgets/Airport\\ Radar.wdgt/"; }			
		// var temp_max_ht = widget.preferenceForKey("max_win_height");
		var temp_mem = widget.preferenceForKey("memory_duration");
		var temp_int = widget.preferenceForKey("scan_interval");
		var temp_srt = widget.preferenceForKey("sort_by");
	
		// if (temp_max_ht != null) { max_win_height = temp_max_ht;}
		if (temp_mem != null) {	memory_duration = temp_mem;}
		if (temp_int != null) {	scan_interval = temp_int;}
		if (temp_srt != null) {	sort_by = temp_srt;}
		
		
		scan_interval_sec = Math.abs(Math.round(scan_interval / 100) / 10);
		document.getElementById('intr').value = scan_interval_sec;
		document.getElementById('memo').value = memory_duration;
		// document.getElementById('max_ht').value = max_win_height;
		
		connected_to();
		// power_test();
		// power_test();
		mainElt = document.getElementById('front');
		stretcher = new Stretcher(mainElt, 150, 212, null);
		stretcher.stretch(event);

		radar_scan();
	
	}


}
function initial2 (results) {
		home_test = results.errorString;
		if (home_test == null) {my_path = "~/Library/Widgets/Airport\\ Radar.wdgt/";}
}
function initial3 (results) {
		machine_test = results.errorString;
		if (machine_test == null) {my_path = "/Library/Widgets/Airport\\ Radar.wdgt/";}
		if (machine_test != null && home_test != null) {
			my_path = "";
			// document.getElementById("sweep_chart").innerHTML = "<center style='color:#444444; font-size:11px;'>Please make sure AirPort is configured and that AirPort Radar is installed in your Widgets folder and reload.<br /><br />Your Widgets folder is located either at \"Library > Widgets\" or \"(Home) > Library > Widgets\"</center>";
		}
}

function change_scan_int(elem) {
	// alert('change_scan_int');

	scan_interval = Math.abs(elem.value * 1000);
	if (scan_interval < 750) { scan_interval = 750;}
	if(window.widget)
	{
		widget.setPreferenceForKey(scan_interval,"scan_interval");
	}
}
function change_scan_mem(elem) {
	// alert('change_scan_mem');
	memory_duration = elem.value;
	if(window.widget)
	{
		widget.setPreferenceForKey(memory_duration,"memory_duration");
	}
}
/*
function change_max_height(elem) {
	// alert('change_scan_mem');
	if (scan_interval < 750) { scan_interval = 750;}
	// max_win_height = elem.value;
	// if (max_win_height < 3) { max_win_height = 3;}
	if(window.widget)
	{
		widget.setPreferenceForKey(max_win_height,"max_win_height");
	}
}*/

function onshow() {
	// alert('onshow');
	// power_test();
	hidden = "0";
	if (document.getElementById("back").style.display != "block") {
		radar_scan();
		// scan_cycle = setInterval("radar_scan();", scan_interval);
	}
}

function onhide() {
	// alert('onhide');
	hidden = "1";
	
}

function onremove () {
	// alert('onremove');

	if (scan_cycle != null){
		clearInterval(scan_cycle);
		scan_cycle = null;
	}
		widget.setPreferenceForKey (null, widget.identifier);
}

function power_test () {
	//alert('power_test');
	power_testa = widget.system("/System/Library/PrivateFrameworks/Apple80211.framework/Resources/airport -I", empty_done);
	power_testa.onreadoutput = power_test2;
	power_testa.onreaderror = power_test2;
	
}
function power_test2 (test_results) {
	//alert ('power_test2 ' + test_results);
	if (test_results == "AirPort: Off\n") {
	//alert ('results say off ');
		mainElt = document.getElementById('front');
		stretcher = new Stretcher(mainElt, 150, 212, null);
		stretcher.stretch(event);
		document.getElementById("sweep_chart").innerHTML = '';
		document.getElementById('power_switch').style.display = 'block';
		document.getElementById('power_image_back').setAttribute('src', 'Images/power_off.png');
		power_state = "off";
		sweep_table = null;
	} else {
	//	alert ('results say not off ');

		document.getElementById('power_switch').style.display = 'none';
		document.getElementById('power_image_back').setAttribute('src', 'Images/power_on.png');
		power_state = "on";
	}
}
function power_on () {
	// alert('power_on');

	// power_test();

	if (power_state == "off") {

		power_on_msg = widget.system(my_path + "radar_sweep -P 1", empty_done);
		power_on_msg.onreadoutput = power_on2;
		power_on_msg.onreaderror = alert_error;
	} else if (power_state == "on") {
		power_it_off = widget.system(my_path + "radar_sweep -P 0", empty_done);
		
		power_it_off.onreadoutput = power_on3;
		power_it_off.onreaderror = alert_error;
	}
}
function alert_error (the_error) {
	alert("error " + the_error);
}
function power_on2 () {
	alert ('power on 2 ');
	power_test();
	radar_scan();

		//power_on_msg2 = widget.system(my_path + "radar_sweep -p", empty_done);
		//power_on_msg2.onreadoutput = power_on3;

}
function power_on3 () {
	alert ('power on 3 ' );
		power_test();
/*
		if (results == "Power is off.\n") {

			document.getElementById('power_switch').innerHTML = 'An error occurred when attempting to turn AirPort on.  Please check Network Preferences.';
			document.getElementById('power_button').src = 'Images/power_off.png';
		} else {
			document.getElementById('power_switch').style.display = 'none';
			document.getElementById('power_image_back').setAttribute('src', 'Images/power_on.png');
			power_state = "on";
		}*/
	
		
	// turn power off if it is on
}

function power_off_check () {
	a_power_test = widget.system(my_path + "radar_sweep -p", empty_done);
	a_power_test.onreadoutput = power_off_check2;
}
function power_off_check2 (results) {
	// alert("power off chcek2 " + results);
	if (results == "Power is off.\n") {
		document.getElementById("sweep_chart").innerHTML = '';
		document.getElementById('power_switch').style.display = 'block';
		document.getElementById('power_image_back').setAttribute('src', 'Images/power_off.png');
		power_state = "off";
		// power_test();
	} else {	
		alert('AirPort Radar Error: AirPort did not turn off.');
	}
}
function show_prefs_prep() {
	hidden = "1";

		if (stretcher.timer != null) {
			clearInterval(stretcher.timer);
			stretcher.timer = null;

		}
		//if (document.getElementById('myScrollBar').style.display == 'block') {
		//	document.getElementById('myScrollBar').style.display = 'none';
		//	restore_scrollbar = 1;
		//}

		mainElt = document.getElementById('front');
		stretcher = new Stretcher(mainElt, 80, 212, showPrefs);
		stretcher.stretch(event);

}
function hide_prefs_prep() {	
	// alert('hide_prefs_prep start');
	hidden = "0";
	radar_scan();
	hidePrefs();

}


// Apple's Stretcher code

/* Copyright _ 2005, Apple Computer, Inc.  All rights reserved. NOTE:  Use of this source code is subject to the terms of the Software License Agreement for Mac OS X, which accompanies the code.  Your use of this source code signifies your agreement to such license terms and conditions.  Except as expressly granted in the Software License Agreement for Mac OS X, no other copyright, patent, or other intellectual property license or right is granted, either expressly or by implication, by Apple. */ 

/*
 ***************************************************************
 * <Stretcher object definition.  Stretches a div up and down> *
 ***************************************************************
 */
 

/* Stretcher constructor.  Parameters:
 * -- element: The element to stretch
 * -- doneNotification: A callback (if no callback is needed, pass null */
function Stretcher (element, lines_needed, width_needed, doneNotification) {
	// alert('Stretcher');

	this.element = element;

	this.startTime = 0;
	this.timer = null;
	
	// min and max position can be changed to alter the stretched/shrunk sizes.
	var computedStyle = document.defaultView.getComputedStyle(this.element, "");
	this.minPosition = parseInt(computedStyle.getPropertyValue("height"));
	this.current_position_x = parseInt(computedStyle.getPropertyValue("width"));
	// this.minPosition = 188;
	
	// this.maxPosition = 300;
	this.maxPosition = 58 + lines_needed + 15;
	this.target_position_x = width_needed;
	
	this.positionFrom = this.minPosition;
	this.positionNow = this.minPosition;
	this.positionFrom_x = this.current_position_x;
	this.positionNow_x = this.current_position_x;
	this.positionTo = 0;
	this.positionTo_x = 0;
	
	this.isCollapsed = false;
	this.stretching = false;
	
	this.stretch = Stretcher_stretch;
	this.tick = Stretcher_tick;
	this.doneNotification = doneNotification;
}

/*
 * This should only be called via a Stretcher instance, i.e. "instance.stretch(event)"
 * Calling Stretcher_stretch() directly will result in "this" evaluating to the window
 * object, and the function will fail.  Parameters:
 * 
 * -- event: the mouse click that starts everything off (from an onclick handler).
 *		We check for the shift key to do a slo-mo stretch.
 */
function Stretcher_stretch (event) {
	// alert('Stretcher_stretch');


	if (this.stretching) return;
	
	var timeNow = (new Date).getTime();
	var multiplier = 1; // enable slo-mo

	var computedHeight = document.defaultView.getComputedStyle(this.element, "").getPropertyValue("height");
	var computed_width = document.defaultView.getComputedStyle(this.element, "").getPropertyValue("width");
	if (this.isCollapsed) {
		// we're shrinking back down.  Save the previous maximized size.
		this.maxPosition = parseInt(computedHeight, 10);
		this.target_position_x = parseInt(computedHeight, 10);
	} else {
		// we're stretching.  Save the previous minimum.
		this.minPosition = parseInt(computedHeight, 10);
		this.current_position_x = parseInt(computedHeight, 10);
	}


	this.stretchTime = 250 * multiplier;
	this.positionFrom = this.positionNow;
	
	var resizeTo = this.isCollapsed ? this.minPosition : this.maxPosition;
	var resizeTo_x = this.isCollapsed ? this.current_position_x : this.target_position_x;

	this.positionTo = parseInt(resizeTo); // lots of hard coding, yum...
	this.positionTo_x = parseInt(resizeTo_x); // lots of hard coding, yum...
	this.startTime = timeNow - 13; // set it back one frame.
/*	*/
	// We need to store this in a local variable so the timer does not lose scope
	// when invoking tick.
	var localThis = this;
	this.stretching = true;
	this.timer = setInterval (function() { localThis.tick(); }, 13);
	this.tick();
}

/*
 * Tick does all the incremental resize work.
 * This function is very similar to the tick() function in the Fader sample.
 */
function Stretcher_tick () {
	// alert('Stretcher_tick this.timer '+this.timer);

	var T;
	var ease;
	var time  = (new Date).getTime();
	var yLoc;
	var frame;
		
	T = limit_3(time-this.startTime, 0, this.stretchTime);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / this.stretchTime));

	if (T >= this.stretchTime) {
		yLoc = this.positionTo;
		clearInterval (this.timer);
		this.timer = null;
		this.isCollapsed = !this.isCollapsed;
		if (this.doneNotification) {
			// call after the last frame is drawn
			var localThis = this;
			setTimeout (function() { localThis.doneNotification(); }, 0);
		}
		this.stretching = false;
	} else {
		yLoc = computeNextFloat(this.positionFrom, this.positionTo, ease);
		xLoc = computeNextFloat(this.positionFrom_x, this.positionTo_x, ease);
		// convert to a integer, not sure if this is the best way
		this.positionNow = parseInt(yLoc);
		this.positionNow_x = parseInt(xLoc);
		this.element.style.height = this.positionNow + "px";
		this.element.style.width = this.positionNow_x + "px";
		window.resizeTo(xLoc, yLoc);
	}
}

/*
 * Support functions for the stretch animation
 */
function limit_3 (a, b, c) {
	// alert('limit_3 ');

    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	// alert('computeNextFloat');

    return from + (to - from) * ease;
}

// end Apple code

function get_stats (input) {
 	// alert('get_stats start');

	newString = " ";
	newdelim = "|";
	regxxxx = /    /g;
	regxxx = /   /g;
	regxx = /  /g;
	belt_a = input.replace(regxxxx, newString);
	belt_b = belt_a.replace(regxxx, newString);
	belt_c = belt_b.replace(regxx, newString);
	belt_out = belt_c.split(" ");
	return belt_out;
}
function get_ssid (input) {
	// alert('get_ssid');

	ssid_chunks = input.split(": ");
	return ssid_chunks[1];
}



function compare_num(a,b) {
	// alert('compare_num');

	return a-b
}

function compare_ssids(a1, a2) {
	// alert('compare_ssids start');

    return a1[0] < a2[0] ? -1 :
           a1[0] > a2[0] ? 1 : 0;
}

function compare_sig_str(a1, a2) {
    return a1[1] < a2[1] ? 1 :
           a1[1] > a2[1] ? -1 : 0;
}


function change_sort_by (how_to_sort) {
	sort_by = how_to_sort;
	if (tree != null) { 
		redraw_table(tree); 
	}
	if(window.widget)
	{
		widget.setPreferenceForKey(sort_by,"sort_by");
		if (how_to_sort == "ssid") {
			document.getElementById("sort_arrow").style.left = "35px";
		} else if (how_to_sort == "sig") {
			document.getElementById("sort_arrow").style.left = "89px";
		} else if (how_to_sort == "channel") {
			document.getElementById("sort_arrow").style.left = "153px";
		}
	}
}

function sort_logic (a1, a2) {
	// alert('sort_logic start');
	if (sort_by == "ssid") {
		b1 = a1.name.toLowerCase();
		b2 = a2.name.toLowerCase();		
    	return b1 < b2 ? -1 :
           b1 > b2 ? 1 : 0;
	} else if (sort_by == "channel") {
		return a1.channel - a2.channel;
	} else if (sort_by == "sig") {
    	return a1.signal < a2.signal ? 1 :
           a1.signal > a2.signal ? -1 : 0;
	} else {
		return 0;
	}

}
function empty_done () {
	var asdf = "";
}
function connected_to ()  {
	// alert('connected_to start');
	the_connect = widget.system("/System/Library/PrivateFrameworks/Apple80211.framework/Resources/airport -I", empty_done);
	the_connect.onreadoutput = connected_to2;

}
function valid_mac (macad) {
	macbits = macad.split(":");
	for (ij=0; ij<macbits.length; ij++) {
		if(macbits[ij] == "0") macbits[ij] = "00";
	}
	return macbits.join(":");
}
function connected_to2 (results)  {
	// alert ("results: " + results);
		the_lines = results.split("\n");
	for (var m = 0 ; m < the_lines.length; m++) { // go through each line
		var i = m - 2;
		// var a_line = the_lines[m];
		// tree[i].name = a_line.substring(0,32);
		// alert ("@@@@ " + the_lines[m].substring(0,15));
		if (the_lines[m].substring(0,15) == "          BSSID") {
			// name_pieces = the_lines[m].split(':');
			my_connected_mac_add = valid_mac(the_lines[m].substring(17,34));
			//alert ("connected to " + my_connected_mac_add);
			// tree[i].encrypted = "1";
		}
		// alert ("scan: " + i + " " +tree[i].name +"        " + tree[i].capability + "   " + tree[i].signal + "   " + tree[i].channel);
	}  
	// tree = removeDuplicates(tree);
}

function connected_to3 (results)  {
	if (results.outputString != null) {
		var parser=new DOMParser();
		var doc=parser.parseFromString(results.outputString,"text/xml");
		items = doc.getElementsByTagName("dict");
		var item = items[0].childNodes;
		var current_base_station = new base_station();
		for (var j = 0; j < item.length ; j++) {
			var this_node = item[j];
			var tag_name = this_node.nodeName;
			if (this_node.hasChildNodes() == true ) {
				if (tag_name == "key") {
					var node_name = this_node.childNodes[0].nodeValue;
				} else {
					if (node_name == "BSSID" ) {
						current_base_station.bssid = this_node.childNodes[0].nodeValue.replace(/[\r|\n|\t]/g, '');
					} 
				}
			}
		}
		my_connected_mac_add = current_base_station.bssid;
	}
}

	 
/*
if (PasswordPlugin){
	// store password
	// PasswordPlugin.makePassword(username, password, key_name);
	// alert ('password plugin yes');
	// retrieve password
	// my_password = PasswordPlugin.getPassword(username, key_name);

}
*/
function do_connect (ssid, locked) {
	// alert('do_connect start');

	newString = "\\ ";
	regx = / /g;
	the_ssid = ssid.replace(regx, newString);
	// alert ("do_connect: " + ssid + " " + locked);
	if (locked >= 1) {		
		/*	 		
		alert ("point 1");
		my_content = ""
		// + "<form onsubmit='do_connect_pwd(\""+the_ssid+"\")'></form>"
		+ "Password for '<span id='password_ssid'></span>'<br><input type='password' id='the_password' size='16' />"
		+ "<span onclick='do_connect_pwd(\""+the_ssid+"\")'>go</span>"
		+ "<input type='hidden' id='ssid_passer' value='"+the_ssid+"' />";
		// alert("my_content = " + my_content);
		document.getElementById('password').innerHTML = my_content;
		document.getElementById('password').style.display = 'block';
			key_command = "security find-generic-password -s AirPort\\ Network -g -a " + the_ssid;
		alert(key_command);
		get_key = widget.system(key_command, null).outputString;
		alert(get_key);
		if (get_key != null) {
			step_a = get_key.split("\n");
			step_b = step_a[19].split('"');
			wep_key = step_b[1];
			command = "radar_sweep -W " + ssid + " " + wep_key;
		} else {

			break	
		}
		*/
		
	} else if (locked==0) {
		command = "/System/Library/PrivateFrameworks/Apple80211.framework/Resources/airport -A" + the_ssid;
		widget.system(command, empty_done);
		// radar_scan();
		// alert("connecting: " +command);
	}
}

function do_connect_pwd (ssid) {
	// alert('do_connect_pwd start');

	pwd = document.getElementById('the_password').value;
	document.getElementById('password').style.display = 'none';

	newString = "\\ ";
	regx = / /g;
	the_ssid = ssid.replace(regx, newString);

	command = "radar_sweep -W " + the_ssid + " " + pwd;
/*
	if (widget.system){
		  widget.system("ls", null).outputString;
	}*/
}
function outputHandler (bobobo) {
	alert ("ERROR!!!! -- " + bobobo);
}
function end_function () {		
	document.getElementById("scanning").style.display ='none';

	// alert("end " + hidden + " " + power_state);
	// the_scan.cancel();
	if (hidden != "1" && power_state == "on") {	
				// alert("rescan okay");

		if (no_scan_results == "1" && waiting_to_scan != "1") {
			// alert("rescan in 5");

			setTimeout('radar_scan()', 5000);
			waiting_to_scan = "1";
		} else { 
			// alert("rescan in 1");
			// var scan_interval = 5000;
			setTimeout('radar_scan()', scan_interval);
		} 
		// radar_scan();
	}

}

function radar_scan () {
	if (hidden != "1" && power_state == "on") {	
		document.getElementById("scanning").style.display ='block';
		// alert ("radar_scan start - - - - - - - - - - - - - - -");
		happening = 1;
		waiting_to_scan = "0";
		// alert ('scan_output.status ' + scan_output.status);
		// scan_output.cancel();
		// scan_output = null;
		// if(scan_output != null) {
		//     scan_output.cancel();
		// }
		the_scan = widget.system("/System/Library/PrivateFrameworks/Apple80211.framework/Resources/airport -s", end_function);
		
		the_scan.onreadoutput = radar_scan_processing;
		the_scan.onreaderror = outputHandler;
	}
}
function radar_scan_error_check (the_output) {

		if (the_output.errorString && had_success != 1) {
			// alert (scan_output.errorString + "  & scan errors = " + scan_errors);
			if (scan_output.errorString.substr(0, 32) == "Error: WirelessScan: -2013261821") {
				scan_errors++;
				if (scan_errors > 5) {
					document.getElementById("sweep_chart").innerHTML = '<div id="error">An error has occurred.<br />Please make sure AirPort is configured in the Network System Preference Pane, or try lowering the scan rate.</div>';
				}
			} 
		} else {
			scan_errors=0;
			had_success = 1;
			// radar_scan_processing (the_output);
		}
}
function parse_results (items) { //  converts the xml to an array of objects that are defined by the class "base_station"
		alert ("number of 'dict's: " + items.length);
		for (var i = 0 ; i < items.length ; i++) {
			var item = items[i];
			var mylength = item.childNodes.length;
			
			
			tree[i] = new base_station();
			for (var j = 0 ; j < mylength ; j++) {
				var this_node = item.childNodes[j];
				var tag_name = this_node.nodeName;
				if (this_node.hasChildNodes() == true ) {
					if (tag_name == "key") {
						var node_name = this_node.childNodes[0].nodeValue;
					} else {
						if (node_name == "name" ) {
							tree[i].name = this_node.childNodes[0].nodeValue;
						} else if (node_name == "signal" ) {
							tree[i].signal = this_node.childNodes[0].nodeValue;
						} else if (node_name == "channel" ) {
							tree[i].channel = this_node.childNodes[0].nodeValue;
						} else if (node_name == "authModes" ) {
							tree[i].authModes = this_node.childNodes[0].nodeValue;
						} else if (node_name == "isWPA" ) {
							tree[i].isWPA = this_node.childNodes[0].nodeValue;
						} else if (node_name == "BSSID" ) {
							tree[i].bssid = this_node.childNodes[0].nodeValue.replace(/[\r|\n|\t]/g, '');
							// index[this_node.childNodes[0].nodeValue.replace(/[\r|\n|\t]/g, '')] = i;
							// alert ("scan: " + tree[i].bssid);
						} else if (node_name == "capability" ) {
							tree[i].capability = this_node.childNodes[0].nodeValue;
							tree[i].encrypted = (tree[i].capability & 0x10) / 16;
						} 
					}	
				 }
			}
			// alert ("sscan: " + i + " " +tree[i].name +" " + tree[i].bssid);
		}  
		// tree = removeDuplicates(tree);
}
function removeDuplicates(arr) {
	var dupe, r, ii, temp, the_removed, arrlen, temp2;
	temp = new Array();
	temp2 = new Array();
	arrlen = arr.length;
	for( r=0; r<arrlen; r++ ) { // going through the main array
		dupe = false;
		for( ii=0; ii<temp.length; ii++ ) {  // go through temporary array of stored values
			if( temp[ii] == arr[r].bssid || arr[r].name == null || isNaN(arr[r].channel) || isNaN(arr[r].signal) || arr[r].channel == '  ' || arr[r].channel == ' ' || arr[r].channel == '') {
				// if it is a duplicate or invalid row, mark as a dupe
				dupe = true;
			} 
		}
		if ( dupe === false) {
			temp.push(arr[r].bssid);
		} else if ( dupe === true ) {  //add to temp2 array - the list of things that will be removed.
			temp2.push(r);
		}
	}
	for( r=temp2.length; r > -1; r-- ) { // going through the temp array removing the duplicates
		if (temp2[r] != undefined) { 
			arr.splice(temp2[r], 1);
		}
	}
	return arr;
}


function split_results (the_results) {
	//alert(the_results);
	tree=new Array();
	the_lines = the_results.split("\n");
	//alert(the_lines[0] + "//// " + the_lines[1]);
	if(the_lines[0].search(/[0-9]+\ Infrastructure\ networks\ found:/) != "-1") {
		the_lines.shift();
	}
	var i=0;
	for (var m = 1 ; m < (the_lines.length - 1); m++) { // go through each line
		//var i = m - 1;
		var a_line = the_lines[m];
		name_header = the_lines[0].match(/^\s+SSID/g) + "";
		// var ch_check = a_line.substring(46,48);
		// if ((ch_check == 'Ch') || (ch_check == '  ')) continue;
		// alert(tree[i].name);
		// tree[i].name = tree[i].name.replace(/^\s*/g, '');
		// a_line = a_line.substring(name_header.length, a_line.length);
		var a_line2 = a_line.substring(name_header.length, a_line.length).replace(" ", '');
		var header2 = the_lines[0].substring(name_header.length, the_lines[0].length).replace(/^\s*/g, '');
		if (header2.substr(0,4) == "Secu")  { // OS X 10.4
				//alert("=== " + a_line2);
			if (a_line2 != "" && a_line2.search(/[0-9]+\ IBSS\ networks\ found:/) == -1 && a_line2.search(/Security[\ ]+Ch[\ ]+Sig/) == -1) {
			 	//alert("+++" + a_line2);

				tree[i] = new base_station();
				tree[i].name = a_line.substring(0,name_header.length).replace(/^\s*/g, ''); // a_line.substring(0,name_header.length);
				tree[i].capability = a_line2.substr(0, 13);

				a_line2 = a_line2.substr(13, a_line2.length).replace(/^\s*/g, '');
				line_parts = a_line2.split(/ +/); // array( channel, signal, vr, ID, IE, BSSID, WPA, ...);
				if(line_parts[1].substr(0,1) == "-" || line_parts[1] < 10) { // negative
					tree[i].signal = parseInt(line_parts[1]) + 90; // scale of 0 - 100
				} else {
					tree[i].signal = ((line_parts[1] -10 ) / 75) * 100; // scale of 0 - 100
				}
				tree[i].bssid = line_parts[5];
				tree[i].channel = line_parts[0];
				

			} else {
				//alert("!!! " + a_line2);
				continue;
			}
		} else { // OS X 10.5
			line_parts = a_line2.split(/ +/); // array( BSSID, RSSI, CHANNEL, SECURITY, ...);
			tree[i] = new base_station();
			tree[i].name = a_line.substring(0,name_header.length).replace(/^\s*/g, ''); // a_line.substring(0,name_header.length);
			tree[i].bssid = line_parts[0];
			tree[i].signal = parseInt(line_parts[1]) + 100; // scale of 0 - 100
			tree[i].channel = line_parts[2];
			tree[i].capability = line_parts[3];
			
		}
		
		
		
		
		
		
	//	alert(tree[i].signal + " " + tree[i].name);
		
		
		
		
		//tree[i].capability =  a_line.substring(33,45);
		//tree[i].channel = a_line.substring(46,48);
		//tree[i].signal = a_line.substring(50,52);
		//tree[i].bssid = a_line.substring(63,80);
		if (tree[i].capability.replace(/^[\s]*/g, '') != "") {
			tree[i].encrypted = "1";
		} else {
			tree[i].encrypted = "0";
		}
		i++;
		// alert ("scan: " + i + " " +tree[i].name +"        " + tree[i].capability + "   " + tree[i].signal + "   " + tree[i].channel);
	}  
	tree = removeDuplicates(tree);

}

function radar_scan_processing (myoutput) {
	if (hidden != "1" && power_state == "on") {	
		connected_to();
		// alert('radar_scan_processing');
		// alert('!!!' + myoutput);
		if ( myoutput.substring(0,15) == "No scan results") { no_scan_results = "1"; } else { no_scan_results = "0";}
	
		win_size = null;
		if (myoutput && no_scan_results == "0") {
			/*
			var parser=new DOMParser();
			var doc=parser.parseFromString(myoutput,"text/xml");
			items = doc.getElementsByTagName("dict");
			tree = null;
			alert (" - - - - - - parse it first - - - - - - - - "); */
			
			
			//alert(myoutput);
			myoutput2="6 Infrastructure networks found:\n"
+"                            SSID Security     Ch Sig Vr  ID IE BSSID             WPA (Auth[]), (Cipher[])                \n"
+"                      DiskEraser WPA PSK       6  20 -1   0  0 00:16:b6:aa:67:bb   1 (2,0,0,0), ( 2(TKIP),0,0,0)\n"
+"                          iawest WEP           6  34 -1   0  0 00:06:25:7d:88:e5   0 (0,0,0,0), (0,0,0,0)\n"
+"                 Lab_11n_Extreme WPA+WPA2 PSK  9  76  1 104  1 00:19:e3:32:c3:96 129 (2,130,0,0), ( 2(TKIP), 132(AES2), 130(TKIP2),0)\n"
+"                     Lab_Extreme WPA PSK      11  71  1   3  0 00:03:93:ee:30:5e   1 (2,0,0,0), ( 2(TKIP),0,0,0)\n"
+"                 Lab_Trendnet_AP WPA2 PSK      4  70 -1   0  0 00:18:e7:01:64:6e 128 (130,0,0,0), ( 132(AES2),0,0,0)\n"
+"                        leonardo               8  40 -1   0  0 00:18:39:45:ff:fb   0 (0,0,0,0), (0,0,0,0)\n"
+"                         2iawest WEP           6  34 -1   0  0 00:06:25:7d:88:e2   0 (0,0,0,0), (0,0,0,0)\n"
+"                2Lab_11n_Extreme WPA+WPA2 PSK  9  76  1 104  1 00:19:e3:32:c3:92 129 (2,130,0,0), ( 2(TKIP), 132(AES2), 130(TKIP2),0)\n"
+"                    2Lab_Extreme WPA PSK      11  71  1   3  0 00:03:93:ee:30:52   1 (2,0,0,0), ( 2(TKIP),0,0,0)\n"
+"                2Lab_Trendnet_AP WPA2 PSK      4  70 -1   0  0 00:18:e7:01:64:62 128 (130,0,0,0), ( 132(AES2),0,0,0)\n"
+"                       2leonardo               8  40 -1   0  0 00:18:39:45:ff:f2   0 (0,0,0,0), (0,0,0,0)\n"
+"                         3iawest WEP           6  34 -1   0  0 00:06:25:7d:88:e3   0 (0,0,0,0), (0,0,0,0)\n"
+"                3Lab_11n_Extreme WPA+WPA2 PSK  9  76  1 104  1 00:19:e3:32:c3:93 129 (2,130,0,0), ( 2(TKIP), 132(AES2), 130(TKIP2),0)\n"
+"                    3Lab_Extreme WPA PSK      11  71  1   3  0 00:03:93:ee:30:53   1 (2,0,0,0), ( 2(TKIP),0,0,0)\n"
+"                3Lab_Trendnet_AP WPA2 PSK      4  70 -1   0  0 00:18:e7:01:64:63 128 (130,0,0,0), ( 132(AES2),0,0,0)\n"
+"                       3leonardo               8  40 -1   0  0 00:18:39:45:ff:f3   0 (0,0,0,0), (0,0,0,0)\n"
+"\n"
+"1 IBSS networks found:\n"
+"                            SSID Security     Ch Sig Vr  ID IE BSSID             WPA (Auth[]), (Cipher[]) \n"               
+"                         hpsetup              11  25 -1   0  0 d2:f2:3b:59:f7:89   0 (0,0,0,0), (0,0,0,0)\n";

			//alert(myoutput);
			
			
			split_results(myoutput);
	
			
			// Remember base stations for some scans
			if (first_time == 1) {
				first_time = 0;
			} else {
				for (jj = "0"; jj < previous_sweep.length; jj++) {
					$k = "0";
					found = 0;
					while ($k < tree.length) {
							if (tree[$k].bssid == previous_sweep[jj].bssid) {
								found = 1;
								$k = tree.length;
							} else {
								$k++;
							}
					}
					if (found == 0) {
						if (previous_sweep[jj].out_count != null) {
							out_count = previous_sweep[jj].out_count + 1;
						} else {
							out_count = 1;
						} 
						if (out_count <= memory_duration) {
							var lost_station = previous_sweep[jj];
							lost_station.out_count = out_count;
							tree.splice(0, 0, previous_sweep[jj]);
						} 
					}
					
				}
			}
		// alert("radar scan processing tree.length " + tree.length);
			previous_sweep = tree;
			var computedStyle = document.defaultView.getComputedStyle(document.getElementById('sweep_chart'), "");
			win_size_px = parseInt(computedStyle.getPropertyValue("height"));
			win_size = Math.round((win_size_px - 17) / 16);
			mainElt = document.getElementById('front');
			/*
			if (tree.length <= max_win_height) {  // lose scrollbar
				document.getElementById('myScrollBar').style.display = 'none';
				// scrollArea.verticalScrollTo(0);
			} else {
	
				document.getElementById('myScrollBar').style.display = 'block';
			}*/
			redraw_table(tree);
			// tree= "";
			/*	
	
			var scroll_bar_style = document.defaultView.getComputedStyle(document.getElementById('myScrollBar'), '');
			if (scroll_bar_style) { 
				myScrollBar_ht = parseInt(scroll_bar_style.getPropertyValue("height")); 
				if (scrollbar._getThumbStartPos() > myScrollBar_ht) { scrollArea.verticalScrollTo(scrollArea.content.scrollTop - scrollArea.viewHeight); }
			}*/
			/*
		} else {
			happening = 0;
			*/
		}
	}
}

function redraw_table (input) {
	if (hidden != "1" && power_state == "on") {	
		// alert("redraw_table (input).length " + input.length);
	
		scrollbar.refresh();
		scrollArea.refresh();
		tree = input.sort(sort_logic);
		my_output = "";
		for (iii=0; iii < tree.length; iii++) {	
			my_ssid = tree[iii].name;
			sig_str = tree[iii].signal;
			encrypted = tree[iii].encrypted;
			if (encrypted > 0) { 
				the_encrypted = "<img src='Images/locked.png'>";
				ssid_link =  my_ssid ;
				if (tree[iii].out_count >= 1) { 
					ssid_activity = "grey_ssid";
					sig_str = '0';
				} else { 
					ssid_activity = "ssid";
				}
	
			} else {
				the_encrypted = "";
				if (tree[iii].out_count >= 1) { 
					ssid_activity = "grey_ssid";
					sig_str = '0';
					ssid_link =  my_ssid;
				} else { 
					ssid_activity = "ssid";
					ssid_link = '<a href="#" onclick="do_connect(\''	+ my_ssid + '\', \'' + encrypted + '\')">' + my_ssid +'</a>';
	
				}
			}
			sig_str = (160/100) * sig_str;
			channel = tree[iii].channel;
			b_g_mode = null;
			// mac_addr = tree[iii].bssid;
			// alert (my_connected_mac_add + " "+tree[iii].bssid);
			if (my_connected_mac_add == tree[iii].bssid) { 
	
				meter_color = "orange"; 
				ssid_link = my_ssid + '</span>';
			} else { 
				meter_color = "blue";
			}
			my_output += '<div class="row">'
				+ '<span><img src="Images/' + meter_color + '_bar16.png" height="16px" width="' + sig_str + 'px"></span>'
				+ '<span class="' + ssid_activity +'">' + ssid_link + '</span>'
				+ '<span class="channel">' + channel + '</span>'
				+ '<span class="encryption">' + the_encrypted + '</span>'
				+ '</div>';
			// alert("draw ### "+my_ssid);
		}
		document.getElementById("sweep_chart").innerHTML = my_output;
		happening = 0;
	}
	// alert(memory_duration+' memory_duration');
}


function base_station() {
  this.name = null;
  this.bssid = null;
  this.signal = null;
  this.channel = null;
  this.authModes = null;
  this.isWPA = null;
  this.capability = null;
  this.encrypted = null;
  this.out_count = null; // how many scans the station has been missing for
 }
 
 
 /*
	capability				1041				***
	channel					1					***
	isWPA					0					***
	multiCipher				0
	name					picante				***
	noise					0
	signal					29					***
*/
